<?php
if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}

// Menu Option Backend
add_action('wp_update_nav_menu_item', 'ask_wp_update_nav_menu_item', 10, 3);
function ask_wp_update_nav_menu_item ($menu_id, $menu_item_db_id, $args) {
	$check = array('menu_link');
	foreach ($check as $key) {
		if (!isset($_POST['menu-item-'.$key][$menu_item_db_id])) {
			$_POST['menu-item-'.$key][$menu_item_db_id] = "";
		}
		$value = $_POST['menu-item-'.$key][$menu_item_db_id];
		update_post_meta($menu_item_db_id,'_menu_item_'.$key,$value);
	}
}

// Setup Menu Option
add_filter( 'wp_setup_nav_menu_item','ask_wp_setup_nav_menu_item' );
function ask_wp_setup_nav_menu_item($menu_item) {
	$menu_item->menu_link = get_post_meta( $menu_item->ID, '_menu_item_menu_link', true );
	return $menu_item;
}

// Hook Menu Walker
add_filter('wp_edit_nav_menu_walker', 'ask_wp_edit_nav_menu_walker');
function ask_wp_edit_nav_menu_walker () {
	return 'ASK_Walker_Nav_Menu_Edit';
}

// Add nav-menu.php to inject Menu Option
require_once ABSPATH . 'wp-admin/includes/nav-menu.php';
class ASK_Walker_Nav_Menu_Edit extends Walker_Nav_Menu_Edit {
	function start_el(&$output, $item, $depth = 0, $args = array(), $id = 0) {
		$item_output = '';
		
		//Menu
		$html = '<p class="field-menu-link description description-wide">
			<label for="edit-menu-item-menu-link-' . $item->ID . '">Profile link</label>
			<select id="edit-menu-item-menu-link-'.esc_attr($item->ID).'" class="widefat" name="menu-item-menu_link['.esc_attr($item->ID).']">
				<option value="none">'.esc_html__('Select the link','vbegy').'</option>
				<option value="top_panel" '.selected($item->menu_link,'top_panel',false).'>'.esc_html__('Top profile panel','vbegy').'</option>
				<option value="side_panel" '.selected($item->menu_link,'side_panel',false).'>'.esc_html__('Side profile panel','vbegy').'</option>
				<option value="profile" '.selected($item->menu_link,'profile',false).'>'.esc_html__('Profile','vbegy').'</option>
				<option value="messages" '.selected($item->menu_link,'messages',false).'>'.esc_html__('Messages','vbegy').'</option>
				<option value="questions" '.selected($item->menu_link,'questions',false).'>'.esc_html__('Questions','vbegy').'</option>
				<option value="polls" '.selected($item->menu_link,'polls',false).'>'.esc_html__('Polls','vbegy').'</option>
				<option value="asked_questions" '.selected($item->menu_link,'asked_questions',false).'>'.esc_html__('Asked Questions','vbegy').'</option>
				<option value="paid_questions" '.selected($item->menu_link,'paid_questions',false).'>'.esc_html__('Paid Questions','vbegy').'</option>
				<option value="answers" '.selected($item->menu_link,'answers',false).'>'.esc_html__('Answers','vbegy').'</option>
				<option value="best_answers" '.selected($item->menu_link,'best_answers',false).'>'.esc_html__('Best Answers','vbegy').'</option>
				<option value="favorites" '.selected($item->menu_link,'favorites',false).'>'.esc_html__('Favorites','vbegy').'</option>
				<option value="followed" '.selected($item->menu_link,'followed',false).'>'.esc_html__('Followed','vbegy').'</option>
				<option value="points" '.selected($item->menu_link,'points',false).'>'.esc_html__('Points','vbegy').'</option>
				<option value="followers" '.selected($item->menu_link,'followers',false).'>'.esc_html__('Followers','vbegy').'</option>
				<option value="following" '.selected($item->menu_link,'following',false).'>'.esc_html__('Following','vbegy').'</option>
				<option value="posts" '.selected($item->menu_link,'posts',false).'>'.esc_html__('Posts','vbegy').'</option>
				<option value="comments" '.selected($item->menu_link,'comments',false).'>'.esc_html__('Comments','vbegy').'</option>
				<option value="followers_questions" '.selected($item->menu_link,'followers_questions',false).'>'.esc_html__('Followers Questions','vbegy').'</option>
				<option value="followers_answers" '.selected($item->menu_link,'followers_answers',false).'>'.esc_html__('Followers Answers','vbegy').'</option>
				<option value="followers_posts" '.selected($item->menu_link,'followers_posts',false).'>'.esc_html__('Followers Posts','vbegy').'</option>
				<option value="followers_comments" '.selected($item->menu_link,'followers_comments',false).'>'.esc_html__('Followers Comments','vbegy').'</option>
				<option value="edit_profile" '.selected($item->menu_link,'edit_profile',false).'>'.esc_html__('Edit Profile','vbegy').'</option>
				<option value="activities" '.selected($item->menu_link,'activities',false).'>'.esc_html__('Activity Log','vbegy').'</option>
				<option value="notifications" '.selected($item->menu_link,'notifications',false).'>'.esc_html__('Notifications','vbegy').'</option>
				<option value="logout" '.selected($item->menu_link,'logout',false).'>'.esc_html__('Logout','vbegy').'</option>
			</select>
			<br><span class="description">Select the link type link profile</span>
		</p>';
		
		parent::start_el($item_output, $item, $depth, $args);
		$item_output = preg_replace('/(?=<p[^>]+class="[^"]*field-title-attribute field-attr-title description description-wide)/', $html, $item_output);
		$output .= $item_output;
	}
}

// Add Menu Class to FrontEnd
add_filter('nav_menu_css_class' , 'ask_menu_class' , 10 , 2);
function ask_menu_class( $classes, $item ) {
	if (isset($item->menu_link) && ($item->menu_link == "top_panel" || $item->menu_link == "side_panel")) {
		if ($item->menu_link == "top_panel") {
			$classes[] = 'login-panel-link';
		}else if ($item->menu_link == "side_panel") {
			$classes[] = 'login-side-link';
		}
	}else if (isset($item->menu_link) && $item->menu_link != "" && $item->menu_link != "none" && is_user_logged_in()) {
		$ask_user_id = get_current_user_id();
		if ($item->menu_link == "profile") {
			$classes[] = 'li-profile';
		}else if ($item->menu_link == "messages") {
			$classes[] = 'li-messages';
		}else if ($item->menu_link == "edit_profile") {
			$classes[] = 'li-edit-profile';
		}else if ($item->menu_link == "followers") {
			$classes[] = 'li-followers';
		}else if ($item->menu_link == "following") {
			$classes[] = 'li-following';
		}else if ($item->menu_link == "notifications") {
			$classes[] = 'li-notifications';
		}else if ($item->menu_link == "activities") {
			$classes[] = 'li-activities';
		}else if ($item->menu_link == "points") {
			$classes[] = 'li-points';
		}else if ($item->menu_link == "questions") {
			$classes[] = 'li-questions';
		}else if ($item->menu_link == "polls") {
			$classes[] = 'li-polls';
		}else if ($item->menu_link == "asked_questions") {
			$classes[] = 'li-asked-questions';
		}else if ($item->menu_link == "paid_questions") {
			$classes[] = 'li-paid-questions';
		}else if ($item->menu_link == "answers") {
			$classes[] = 'li-answers';
		}else if ($item->menu_link == "best_answers") {
			$classes[] = 'li-best-answers';
		}else if ($item->menu_link == "followed") {
			$classes[] = 'li-followed';
		}else if ($item->menu_link == "favorites") {
			$classes[] = 'li-favorites';
		}else if ($item->menu_link == "posts") {
			$classes[] = 'li-posts';
		}else if ($item->menu_link == "comments") {
			$classes[] = 'li-comments';
		}else if ($item->menu_link == "followers_questions") {
			$classes[] = 'li-followers-questions';
		}else if ($item->menu_link == "followers_answers") {
			$classes[] = 'li-followers-answers';
		}else if ($item->menu_link == "followers_posts") {
			$classes[] = 'li-followers-posts';
		}else if ($item->menu_link == "followers_comments") {
			$classes[] = 'li-followers-comments';
		}else if ($item->menu_link == "logout") {
			$classes[] = 'li-logout';
		}
		
		if (($item->menu_link == "profile" && is_author()) || ($item->menu_link == "edit_profile" && is_page_template("template-edit_profile.php")) || ($item->menu_link == "followers" && is_page_template("template-followers.php")) || ($item->menu_link == "following" && is_page_template("template-i_follow.php")) || ($item->menu_link == "notifications" && is_page_template("template-notifications.php")) || ($item->menu_link == "activities" && is_page_template("template-activity_log.php")) || ($item->menu_link == "messages" && is_page_template("template-messages.php")) || ($item->menu_link == "questions" && is_page_template("template-user_question.php")) || ($item->menu_link == "answers" && is_page_template("template-user_answer.php")) || ($item->menu_link == "best_answers" && is_page_template("template-user_best_answer.php")) || ($item->menu_link == "points" && is_page_template("template-user_points.php")) || ($item->menu_link == "polls" && is_page_template("template-user_polls.php")) || ($item->menu_link == "asked_questions" && is_page_template("template-asked_question.php")) || ($item->menu_link == "paid_questions" && is_page_template("template-user_paid_question.php")) || ($item->menu_link == "followed" && is_page_template("template-user_followed_questions.php")) || ($item->menu_link == "favorites" && is_page_template("template-user_favorite_questions.php")) || ($item->menu_link == "posts" && is_page_template("template-user_posts.php")) || ($item->menu_link == "comments" && is_page_template("template-user_comments.php")) || ($item->menu_link == "followers_questions" && is_page_template("template-question_follow.php")) || ($item->menu_link == "followers_answers" && is_page_template("template-answer_follow.php")) || ($item->menu_link == "followers_posts" && is_page_template("template-post_follow.php")) || ($item->menu_link == "followers_comments" && is_page_template("template-comment_follow.php"))) {
			$classes[] = 'current-menu-item current_page_item';
		}
	}
    return $classes;
}

// Menu FrontEnd
add_filter( 'walker_nav_menu_start_el', 'ask_walker_nav_menu_start_el', 10, 4 );
function ask_walker_nav_menu_start_el( $item_output, $item, $depth, $args ) {
	// link attributes
	$attributes  = ! empty($item->attr_title)? ' title="'.esc_attr($item->attr_title).'"' : '';
	$attributes .= ! empty($item->target)    ? ' target="'.esc_attr($item->target  ).'"' : '';
	$attributes .= ! empty($item->xfn)       ? ' rel="'  .esc_attr($item->xfn     ).'"' : '';
	if (isset($item->menu_link) && $item->menu_link != "" && $item->menu_link != "none" && is_user_logged_in()) {
		$ask_user_id = get_current_user_id();
		
		$get_lang = esc_attr(get_query_var("lang"));
		$get_lang_array = array();
		if (isset($get_lang) && $get_lang != "") {
			$get_lang_array = array("lang" => $get_lang);
		}
		
		if ($item->menu_link == "profile") {
			$attributes .= ' href="'.esc_url(vpanel_get_user_url($ask_user_id)).'"';
		}else if ($item->menu_link == "messages") {
			$attributes .= ' href="'.esc_url(get_page_link(vpanel_options('messages_page'))).'"';
		}else if ($item->menu_link == "edit_profile") {
			$attributes .= ' href="'.esc_url(get_page_link(vpanel_options('user_edit_profile_page'))).'"';
		}else if ($item->menu_link == "followers") {
			$attributes .= ' href="'.esc_url(add_query_arg(array_merge(array("u" => esc_attr($ask_user_id),$get_lang_array)),get_page_link(vpanel_options('followers_user_page')))).'"';
		}else if ($item->menu_link == "following") {
			$attributes .= ' href="'.esc_url(add_query_arg(array_merge(array("u" => esc_attr($ask_user_id),$get_lang_array)),get_page_link(vpanel_options('i_follow_user_page')))).'"';
		}else if ($item->menu_link == "notifications") {
			$attributes .= ' href="'.esc_url(get_page_link(vpanel_options('notifications_page'))).'"';
		}else if ($item->menu_link == "activities") {
			$attributes .= ' href="'.esc_url(get_page_link(vpanel_options('activity_log_page'))).'"';
		}else if ($item->menu_link == "points") {
			$attributes .= ' href="'.esc_url(add_query_arg(array_merge(array("u" => esc_attr($ask_user_id),$get_lang_array)),get_page_link(vpanel_options('point_user_page')))).'"';
		}else if ($item->menu_link == "questions") {
			$attributes .= ' href="'.esc_url(add_query_arg(array_merge(array("u" => esc_attr($ask_user_id),$get_lang_array)),get_page_link(vpanel_options('question_user_page')))).'"';
		}else if ($item->menu_link == "polls") {
			$attributes .= ' href="'.esc_url(add_query_arg(array_merge(array("u" => esc_attr($ask_user_id),$get_lang_array)),get_page_link(vpanel_options('polls_user_page')))).'"';
		}else if ($item->menu_link == "asked_questions") {
			$attributes .= ' href="'.esc_url(add_query_arg(array_merge(array("u" => esc_attr($ask_user_id),$get_lang_array)),get_page_link(vpanel_options('asked_question_user_page')))).'"';
		}else if ($item->menu_link == "paid_questions") {
			$attributes .= ' href="'.esc_url(add_query_arg(array_merge(array("u" => esc_attr($ask_user_id),$get_lang_array)),get_page_link(vpanel_options('paid_question')))).'"';
		}else if ($item->menu_link == "answers") {
			$attributes .= ' href="'.esc_url(add_query_arg(array_merge(array("u" => esc_attr($ask_user_id),$get_lang_array)),get_page_link(vpanel_options('answer_user_page')))).'"';
		}else if ($item->menu_link == "best_answers") {
			$attributes .= ' href="'.esc_url(add_query_arg(array_merge(array("u" => esc_attr($ask_user_id),$get_lang_array)),get_page_link(vpanel_options('best_answer_user_page')))).'"';
		}else if ($item->menu_link == "followed") {
			$attributes .= ' href="'.esc_url(add_query_arg(array_merge(array("u" => esc_attr($ask_user_id),$get_lang_array)),get_page_link(vpanel_options('followed_user_page')))).'"';
		}else if ($item->menu_link == "favorites") {
			$attributes .= ' href="'.esc_url(add_query_arg(array_merge(array("u" => esc_attr($ask_user_id),$get_lang_array)),get_page_link(vpanel_options('favorite_user_page')))).'"';
		}else if ($item->menu_link == "posts") {
			$attributes .= ' href="'.esc_url(add_query_arg(array_merge(array("u" => esc_attr($ask_user_id),$get_lang_array)),get_page_link(vpanel_options('post_user_page')))).'"';
		}else if ($item->menu_link == "comments") {
			$attributes .= ' href="'.esc_url(add_query_arg(array_merge(array("u" => esc_attr($ask_user_id),$get_lang_array)),get_page_link(vpanel_options('comment_user_page')))).'"';
		}else if ($item->menu_link == "followers_questions") {
			$attributes .= ' href="'.esc_url(add_query_arg(array_merge(array("u" => esc_attr($ask_user_id),$get_lang_array)),get_page_link(vpanel_options('follow_question_page')))).'"';
		}else if ($item->menu_link == "followers_answers") {
			$attributes .= ' href="'.esc_url(add_query_arg(array_merge(array("u" => esc_attr($ask_user_id),$get_lang_array)),get_page_link(vpanel_options('follow_answer_page')))).'"';
		}else if ($item->menu_link == "followers_posts") {
			$attributes .= ' href="'.esc_url(add_query_arg(array_merge(array("u" => esc_attr($ask_user_id),$get_lang_array)),get_page_link(vpanel_options('follow_post_page')))).'"';
		}else if ($item->menu_link == "followers_comments") {
			$attributes .= ' href="'.esc_url(add_query_arg(array_merge(array("u" => esc_attr($ask_user_id),$get_lang_array)),get_page_link(vpanel_options('follow_comment_page')))).'"';
		}else if ($item->menu_link == "logout") {
			$protocol = is_ssl() ? 'https' : 'http';
			$attributes .= ' href="'.wp_logout_url(wp_unslash( $protocol.'://'.$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'])).'"';
		}else {
			$attributes .= ' href="'.esc_url($item->url).'"';
		}
	}else {
		$attributes .= ' href="'.esc_url($item->url).'"';
	}
	$item_output = '';
	if (isset($args->before)) {
		$item_output = $args->before;
	}
	
	if ((isset($item->menu_link) && $item->menu_link != "" && $item->menu_link != "none" && $item->menu_link != "top_panel" && $item->menu_link != "side_panel" && !is_user_logged_in())) {
		
	}else {
		$item_output .= '<a class="" '.$attributes.'>';
		$item_output .= apply_filters('the_title',$item->title,$item->ID);
		$item_output .= '</a>';
	}
	
	if (isset($args->after)) {
		$item_output .= $args->after;
	}
	return $item_output;
}